import React, { Component } from 'react';

export default class App extends Component {
  constructor(props) {
    super(props);
    
    this.ROWS = 10000;
    this.COLUMNS = 25;
    
    this.state = { data: [] };    
  }
  
//  componentDidMount() {
//    this.init();
//  }                   
  
  init() {
    const data = [];
    
    for(let i = 0; i < this.ROWS; i++) {
      const row = [];
      
      for(let j = 0; j < this.COLUMNS; j++) {
        row.push(`${i}:${j}`);
      }
      
      data.push(row);
    }
    
    this.setState({data});
  }

  changeRow(index) {
    const data = this.state.data;
    
    data[index] = data[index].map(column => `${column}.`);
    
    this.setState({ data });
  }
  
  createRow(row, index) {
    return <tr key={ index.toString() } onClick={ () => this.changeRow(index) }>
    {
      row.map((column, index) => <td key={ index.toString()}>{ column }</td>)
    }
    </tr>;
  }
  
  render() {
    return <div>
      <button onClick={ () => this.init() }>load</button>
      <table>
        <tbody>
          {
            this.state.data.map((row, index) => this.createRow(row, index))            
          }
        </tbody>
      </table>
    </div>;
  }
}





