import React, { Component } from 'react';
import Row from './row';

export default class App extends Component {
  constructor(props) {
    super(props);
    
    this.ROWS = 10000;
    this.COLUMNS = 25;
    
    this.page = 1000;
    this.shown = 0;
    
    this.state = { data: [] };    
  }
  
//  componentDidMount() {
//    this.init();
//  }                   
  
  init() {
    this.initChunks();
  }
  
  initChunks() {
    const data = this.state.data;

    for(let i = this.shown; i < Math.min(this.ROWS, (this.shown + this.page)); i++) {
      const row = [];
      
      for(let j = 0; j < this.COLUMNS; j++) {
        row.push(`${i}:${j}`);
      }
      
      data.push(row);
    }
    
    this.setState({data}, () => {
      if(this.shown < this.ROWS) {
        //in reality data will come from the server.
        //We can make request for each chunk and 
        //render it as it comes through.
        //fetch('index.html')
        //  .then(response => this.initChunks());
        
        setTimeout(() => this.initChunks(), 0); //smells a bit
      }
    });
    
  }

  changeRow(index) {
    const data = this.state.data;
    
    data[index] = data[index].map(column => `${column}.`);
    
    this.setState({ data });
  }
  
//  createRow(row, index) {
//    return <tr key={ index.toString() } onClick={ () => this.changeRow(index) }>
//    {
//      row.map((column, index) => <td key={ index.toString()}>{ column }</td>)
//    }
//    </tr>;
//  }
  
  render() {
    return <div>
      <button onClick={ () => this.init() }>load</button>
      <table>
        <tbody>
          {
            this.state.data.map((row, index) => <Row key={ index.toString() } index={ index } row={ row } changeRow={ index => this.changeRow(index) } />)
          }
        </tbody>
      </table>
    </div>;
  }
}





